<template>
  <b-form-group
    v-if="isVisible"
    :label="label"
    :label-for="id"
    :description="desc"
    :state="fieldState"
    :invalid-feedback="fieldFeedback"
    horizontal>
    <template v-if="fieldType === 'checkbox'">
      <b-form-checkbox-group
        :ref="id"
        :id="id"
        :value="value"
        :state="fieldState"
        :options="fieldAttrs.options || []"
        :disabled="isDisabled"
        :required="isRequired"
        @input="onInput" />
    </template>

    <template v-else-if="fieldType === 'radio'">
      <b-form-radio-group
        :ref="id"
        :id="id"
        :value="value"
        :state="fieldState"
        :options="fieldAttrs.options || []"
        :disabled="isDisabled"
        :required="isRequired"
        @input="onInput" />
    </template>

    <template v-else-if="fieldType === 'select'">
      <b-form-select
        :ref="id"
        :id="id"
        :value="value"
        :state="fieldState"
        :options="fieldAttrs.options || []"
        :disabled="isDisabled"
        :required="isRequired"
        @input="onInput">
        <template slot="first">
          <!-- this slot appears above the options from 'options' prop -->
          <option :value="null" disabled>-- Select {{ label }} --</option>
        </template>
      </b-form-select>
    </template>

    <template v-else-if="['textarea', 'address'].includes(fieldType)">
      <b-form-textarea
        :ref="id"
        :id="id"
        :value="value"
        :state="fieldState"
        :rows="fieldAttrs.rows"
        :multiple="fieldAttrs.multiple || false"
        :disabled="isDisabled"
        :required="isRequired"
        @input="onInput" />
    </template>

    <template v-else-if="['file', 'image'].includes(fieldType)">
      <b-form-file
        :ref="id"
        :id="id"
        :value="value"
        :state="fieldState"
        :disabled="isDisabled"
        :required="isRequired"
        @input="onInput" />
    </template>

    <template v-else-if="['date', 'time', 'datetime', 'boolean'].includes(fieldType)">
      <span class="form-control form-control-static">WIP</span>
    </template>

    <template v-else-if="['id', 'static'].includes(fieldType)">
      <span class="form-control form-control-static">{{ value }}</span>
    </template>

    <template v-else>
      <b-form-input
        :type="fieldType"
        :ref="id"
        :id="id"
        :value="value"
        :state="fieldState"
        :disabled="isDisabled"
        :required="isRequired"
        @input="onInput" />
    </template>
  </b-form-group>
</template>

<script>
import { mapGetters } from 'vuex'

const supportedTypes = [
  'group', // TODO
  'static', // TODO
  'text',
  'textarea',
  'address', // TODO
  'editor', // TODO
  'code', // TODO
  'password',
  'number',
  'currency', // TODO
  'tel',
  'email',
  'url',
  'file', // TODO
  'image', // TODO
  'date', // TODO
  'time', // TODO
  'datetime', // TODO
  'color',
  'select',
  'checkbox',
  'radio',
  'boolean' // TODO
]

export default {
  name: 'form-field',

  props: {
    label: {
      type: String,
      default: ''
    },
    id: {
      type: String,
      required: true
    },
    desc: String,
    type: {
      type: String,
      required: true,
      validator (value) {
        return supportedTypes.includes(value)
      }
    },
    attrs: {
      type: Object,
      default () {
        return {}
      }
    },
    value: {
      default: null
    }
  },

  computed: {
    ...mapGetters(['alerts', 'isBusy']),

    isValid () {
      return !(this.alerts.errors && this.alerts.errors[this.id])
    },

    isVisible () {
      const action = (this.$route.name || '.').split('.')[1]

      if (action === 'create') {
        return this.attrs.showWhenCreating
      }

      return this.attrs.showWhenUpdating
    },

    isDisabled () {
      return this.isBusy || this.attrs.disabled
    },

    isRequired () {
      return this.attrs.required || null
    },

    fieldAttrs () {
      const attrs = Object.assign({}, this.attrs || {})

      attrs.disabled = attrs.disabled || this.isBusy

      return attrs
    },

    fieldState () {
      return this.isValid ? null : false
    },

    fieldFeedback () {
      return !this.isValid
        ? this.alerts.errors[this.id].join(', ')
        : null
    },

    fieldType () {
      return this.type
    }
  },

  methods: {
    onInput (value) {
      this.$emit('input', value)
    }
  }
}
</script>
